BASE = {

  ClassName = "BASE"

}

function BASE:New()
  local Child = mist.utils.deepCopy( self )
  local Parent = {}
  setmetatable( Child, Parent )
  Child.__index = Child
  return Child
end


function BASE:Inherit( Child, Parent )
  local Child = mist.utils.deepCopy( Child )
  local Parent = mist.utils.deepCopy( Parent )
  if Child ~= nil then
    setmetatable( Child, Parent )
    Child.__index = Child
  end
--env.info( "BASE:New() New inherited instance for " .. Child.ClassName ) 
  return Child
end

function BASE:Inherited( Child )
	local Parent = getmetatable( Child )
--	env.info('Inherited class of ' .. Child.ClassName .. ' is ' .. Parent.ClassName )
	return Parent
end


